      SUBROUTINE EC01R(N,DT,A,Y,P,EPS,L,H,X,Z)
      DIMENSION A(N),Y(N),H(7),X(N),Z(N)
      INTEGER N,L,I,N1,N2,N3,K
      REAL DT,A,Y,P,EPS,H,X,Z,Q,B,C,D,S,R1,R2,R3,R4,R5,E,DW,
     1P1,V,W,R,ALP,S1,S2,SYS003
      DATA  SYS003/6.283185/
      N1=N/2
      GO TO (1,7,4),L
    1 DO 2 I=1,N
    2 X(I)=0.
      Q=1.
      CALL FTF1C(A,X,N,1,1,Q)
      DO 3 I=2,N1
      N2=N1+I
    3 A(N2)=X(I)
    4 DO 5 I=1,N
    5 X(I)=0.
      Q=1.
      CALL FTF1C(Y,X,N,1,1,Q)
      DO 6 I=2,N1
      N2=N1+I
    6 Y(N2)=X(I)
    7 B=1./N
      C=1./DT
      D=DT*DT
      S=0.
      DO 8 I=2,N1
      N2=N1+I
      R1=Y(I)
      R2=Y(N2)
    8 S=S+R1*R1+R2*R2
      N3=N/2+1
      S=(S*2+Y(1)*Y(1)+Y(N3)*Y(N3))*DT*B
      S=SQRT(S)
      E=1./(EPS*S)
      DW=SYS003*B*C
      P1=2*P
      V=0.
      K=0
    9 Q=V*D
      S1=0.
      S2=0.
      DO 10 I=2,N1
      N2=N1+I
      R1=A(I)
      R2=A(N2)
      R1=R1*R1+R2*R2
      R2=Y(I)
      R3=Y(N2)
      R2=R2*R2+R3*R3
      W=DW*(I-1)
      R=W**P1
      R3=1./(Q*R1+R)
      R2=R2*(R*B)*R*R3*R3
      S1=S1+R2
      R1=R2*R1*R3
   10 S2=S2+R1
      R=(DW*N1)**P1
      R3=1./(Q*A(N3)*A(N3)+R)
      R2=Y(N3)*Y(N3)*(R*B)*R*R3*R3
      R4=0.
      IF(P.EQ.0.) R4=1./(Q*A(1)*A(1)+1.)
      R5=Y(1)*Y(1)*B*R4*R4
      S1=SQRT((S1*2+R5+R2)*DT)
      R1=S1*E
      IF(R1-1.001) 11,11,14
   11 IF(V) 12,12,16
   12 R4=Y(1)*B*C/A(1)
      IF(P.EQ.0.) R4=0.
      DO 13 I=1,N
   13 X(I)=R4
      H(1)=SQRT(S*S-Y(1)*Y(1)*DT*B)
      IF(P.EQ.0.) H(1)=S
      H(2)=0.
      H(3)=H(1)
      H(4)=0.
      H(5)=1.E+18
      H(6)=0.
      H(7)=H(1)/S
      GO TO 20
   14 IF(P.EQ.0.) R5=R5*A(1)*A(1)*R4
      IF(P.GT.0.) R5=0.
      R2=R2*A(N3)*A(N3)*R3
      R4=1./S1
      S2=-(S2*2.*R4+R5*R4+R2*R4)*(D*DT)
      IF(S2.EQ.0.) ALP=0.
      IF(S2.EQ.0.) GO TO 15
      S2=S1/S2*(1.-R1)
      V=V+S2
      K=K+1
      ALP=1./V
      IF(ALP) 15,15,9
   15 S1=0.
   16 H(1)=S1
      H(5)=ALP
      H(6)=K
      H(7)=H(1)/S
      Q=ALP*C*C
      S1=0.
      S2=0.
      DO 17 I=2,N1
      N2=N1+I
      R1=A(I)
      R2=A(N2)
      R3=Y(I)
      R4=Y(N2)
      W=DW*(I-1)
      R=W**P1
      R5=1./(R1*R1+R2*R2+Q*R)
      E=((R1*R3+R2*R4)*C)*R5
      R2=((R1*R4-R2*R3)*C)*R5
      X(I)=E
      Z(I)=R2
      R3=(R*B)*(E*E+R2*R2)
      S1=S1+R3
      R4=W*((ALP*R5)*R)*(ALP*R5)*R3
   17 S2=S2+R4
      R3=0.
      IF(P.EQ.0.) R3=1.
      X(1)=A(1)*Y(1)*C/(A(1)*A(1)+Q*R3)
      R=(DW*N1)**P1
      R5=1./(A(N3)*A(N3)+Q*R)
      X(N3)=(A(N3)*Y(N3)*C)*R5
      S1=(S1*2.+(R3*B)*X(1)*X(1)+(R*B)*X(N3)*X(N3))*DT
      H(2)=SQRT(S1)
      H(3)=SQRT(H(1)*H(1)+ALP*S1)
      R5=((ALP*R5)*R)*X(N3)
      R4=(DW/2.*R5)*R5
      H(4)=SQRT((S2*2+R4)*C)*C
      Z(1)=0.
      Z(N3)=0.
      N3=N+2
      DO 18 I=2,N1
      N2=N3-I
      X(N2)=X(I)
   18 Z(N2)=-Z(I)
      Q=-1.
      CALL FTF1C(X,Z,N,1,1,Q)
      DO 19 I=1,N1
      R=X(I)*B
      N2=N1+I
      X(I)=X(N2)*B
   19 X(N2)=R
   20 RETURN
      END
